/* SCCS  %W%---%E%--%U% */
/* ---------------------------------------------------------*/
/* decapitate.c */
/* printf("\n usage: decapitate -i foo.c -o foo2.c -n 1\n\n); */
/* ---------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <sys/wait.h>

#define LINE_WIDTH_256 256
#define MED_WIDTH_20 20
#define BIG_WIDTH_120 120
#define MAX_LN_FILENAME LINE_WIDTH_256 

static int debug = 0;

/* ----------------------------------------------------- */
/* Routine: Delete_n_lines_from_top(char * filename) */
/* returns: error -  0 good, positive bad */
/* ----------------------------------------------------- */
int Delete_n_lines_from_top(char * filename1,char * filename2, int num_lines)
{
  FILE *fd1ptr;
  FILE *fd2ptr;
  char buf[LINE_WIDTH_256+1];
  int i;
  int max=LINE_WIDTH_256+1;
  int n;
  int m;
  char * chptr;

  fd1ptr = fopen(filename1,"r");
  if (fd1ptr==NULL) {
    printf("Could not open file for read %s \n",filename1);
    return(1);
  } else {
    fd2ptr = fopen(filename2,"w");
    if (fd2ptr==NULL) {
      printf("Could not open file for write %s \n",filename2);
      return(2);
    } else {
      i=0;
      chptr=fgets(buf,max,fd1ptr);
      while ( (i<(num_lines-1)) && (chptr!=NULL)) {
        /* do not write anything */
        i++;
        chptr=fgets(buf,max,fd1ptr);
      }
	/* c evaluates in order */
	/* fgets reads \n  */
      while ( (chptr!=NULL) && ( (fgets(buf,max,fd1ptr)!=NULL))) {
	printf("%s",buf);
	fprintf(fd2ptr,"%s",buf);
      }	
      fclose(fd2ptr);
    }
    fclose(fd1ptr);
  }
  return(0);
}
/* ----------------------------------------------------- */
/* Routine: main */
/* returns: 1 on error */
/* ----------------------------------------------------- */



main(int argc, char *argv[]) 
{
  extern char *optarg;
  extern int optind;
  extern int opterr;
  char c = 'a';
  long errflg=0;
  long i=0;
  long atleastonce=0;

  char * charptr; 
  long inputfile_yes=0;
  long outputfile_yes=0;
  char infilename[MAX_LN_FILENAME];
  char outfilename[MAX_LN_FILENAME];

  int num_lines=0;

  while ((c = getopt(argc, argv, "i:o:n:")) != -1) {
    atleastonce=1;
    switch (c) {
            case 'i':
              inputfile_yes=1;
              strncpy(infilename,optarg,(MAX_LN_FILENAME-1));
              infilename[MAX_LN_FILENAME-1]='\0';
              break;
            case 'o':
              outputfile_yes=1;
              strncpy(outfilename,optarg,(MAX_LN_FILENAME-1));
              outfilename[MAX_LN_FILENAME-1]='\0';
              break;
            case 'n':
  		i=sscanf(optarg,"%d",&num_lines);
	        if (i<1) {
	              errflg=1000;
		}
	        if (num_lines<1) {
	              errflg=1003;
		}
              break;

            case '?':
              errflg=1001;
              break;
            default:
              errflg=1002;
              break;
    }
  }
  if ((!atleastonce)&&(!outputfile_yes)&&(!inputfile_yes)&&(num_lines>=1)) {
         errflg=1004;
	 printf("\n usage: decapitate -i foo.c -o foo2.c -n 1\n\n");
  }
  else {
    errflg=Delete_n_lines_from_top(infilename,outfilename,num_lines);
  }
  printf("errflag=%d\n",errflg);
  return(errflg);
}



