// asl.h

#pragma interface

#ifndef __ASL_H
#define __ASL_H 1

// PVM constants

const int CTRL = 555;	// for commands data
const int INIT = 655;	// for initializing AslSystem
const int ACK =  755;	// for acknowledge to console

// Constants

const int ASL_NAME_LEN = 80;

const int EXTERNAL = 1;
const int INTERNAL = 2;

const int NORMAL  = 1;
const int POINTER = 2;
const int VECTOR  = 3;
const int MATRIX  = 4;

const int MAKECONN    = 0;
const int INITRUN     = 1;
const int SIMRUN      = 2;
const int MAKEDISCONN = 3;
const int END         = 4;
// const int BUSY	= 5;
const int READY       = 6;

const int ASL_SIGNAL = 0;
const int ASL_THREAD = 1;

const int ASL_MAXENV = 256;

const int ASL_DATA_INPUT     = 1;	//antes tenia un 0
const int ASL_DATA_OUTPUT    = 2;	//antes un 1
const int ASL_CONTROL_INPUT  = 3;
const int ASL_CONTROL_OUTPUT = 4;
const int ASL_NEW_CONTAINER  = 5;
const int ASL_RELABEL_BUFFER = 6;

// added for identificate nsl-types
const ASL_CHAR		= 10;
const ASL_INT		= 11;
const ASL_FLOAT		= 12;
const ASL_DOUBLE	= 13;
const ASL_LONG		= 14;
const ASL_SHORT		= 15;
const ASL_VECTOR	= 16;
// --------------------------------

const int TRUE = 1;
const int FALSE = 0;

extern int asl_debug;

typedef void* any_t;
#define asl_any_t         any_t
#define asl_size_t        size_t

#define asl_thread_t      thread_t
#define asl_mutex_t       mutex_t
#define asl_cond_t        cond_t

typedef asl_any_t(*asl_thread_func_t)(asl_any_t);
typedef void(*asl_thread_proc_t)(void);

class AslPortRelations;
class AslSchema_Pvm;
class AslState;

class AslSystem;

class AslSchema;
class AslSchemaInterface;

class AslFunction;
class AslPort;

template<class T>  class AslList;
typedef AslList<AslSchema> AslListSchema;

class AslErr;
class AslInOut;
class AslTerminator;
class AslIPCManager;
class AslThreadManager;
class AslThread;
class AslMutex;
class AslCondition;

extern AslErr        aslerr;
extern AslInOut      aslio;
extern AslTerminator aslend;
extern AslIPCManager *AslCom;
extern AslSystem     *asl;
extern AslThreadManager *aslScheduler;

extern struct aslArgument;

extern void AslTclGraphInit(aslArgument);
extern void AslTclGeneralScheduler(AslSystem*);
//extern void ASLrefresh(void);

//extern AslMutex MutexExec;

//extern int NslLoad(char*);

#endif
