/* SCCS  @(#)nsl_sys_main.C	1.1---95/08/13--21:10:41 */
/**************************************************************/
/*                                                            */
/*                       asl_sys_main.C                       */
/*                                                            */
/**************************************************************/

# include "nsl_all_kernel_include.h"
# include "asl_all_rts_include.h"

#ifdef CONSOLE
	# include "xnsl_all_xkernel_include.h"
#endif

//extern nsl_public* SYS_INTERFACE;

/*
#ifdef NSL_TK
	#include "tk.h"
#else
	#include "tcl.h"
#endif

extern Tcl_Interp *interp;
extern int NSL_TK_FLUSH;
*/

// global data definition

AslSystem *asl,*ASL_SYSTEM;
// AslIPCManager *comm;
AslIPCManager *AslCom;
AslThreadManager *aslScheduler;

AslInOut aslio;
AslErr   aslerr;
AslTerminator aslend;
//AslMutex GraphMutex;

int    asl_debug;			// If <> 0, then output debug info

// -----------------
void ASLinit(int argc, char **argv)
{
	asl = new AslSystem(argc, argv);

	ASL_SYSTEM = asl;
  	
	if (ASL_SYSTEM != NULL && NSL_SYSTEM != NULL)
		NSL_SYSTEM->set_asl_system(ASL_SYSTEM);
	else
		cmd_out("ASLinit: Null SYSTEM");
}
int ASLsys()
{
	if (ASL_SYSTEM != NULL)
		((AslSystem*) ASL_SYSTEM)->AslDoListInitSys(); 
	else
		cmd_out("ASLrun: Null ASL_SYSTEM");
		
	return 1;
}

asl_any_t ThreadConsole(void)
{
#ifdef CONSOLE
//	GraphMutex.AslLock();

	((AslSystem*) ASL_SYSTEM)->AslAcceptGraphData("GraphPort");

        if (XNSL_SYSTEM /*SYS_INTERFACE*/ != NULL)
        {
//              if (t0 == 0.0)
//                    SYS_INTERFACE->clear();

	aslio << " `'`'`'`'`'`' GRAFICANDO '`'`'`'`'`'`'`" << aslend;	
                XNSL_SYSTEM->display(); /*SYS_INTERFACE->display();*/
        }
        else
		aslio << " @@@@@^^^^@@@@@^^^^ No grafico  @@@@@^^^^@@@@@^^^^"<< aslend;	        
//	GraphMutex.AslUnlock();        
#endif	
	return NULL;
}
void ASLrun(int time_step)
{	
	int fg = 1;

	if (ASL_SYSTEM != NULL)
	{
		if (time_step == 0) 
		{
			fg = ((AslSystem*) ASL_SYSTEM)->AslDoListInitRun();
#ifdef CONSOLE
                /*aslScheduler->AslCreateThreadLWP((asl_thread_func_t)ThreadConsole,(any_t)NULL); */ // EN UN THREAD
                	ThreadConsole();
#endif
		}
		else if (time_step == -1)
			fg = ((AslSystem*) ASL_SYSTEM)->AslDoListEndRun();
		else
		{
			fg = ((AslSystem*) ASL_SYSTEM)->AslDoListSimRun();
#ifdef CONSOLE
                /*aslScheduler->AslCreateThreadLWP((asl_thread_func_t)ThreadConsole,(any_t)NULL); */ // EN UN THREAD
                	ThreadConsole();
#endif
		}
	}
	else
		cmd_out("ASLrun: Null ASL_SYSTEM");
	
	if (asl_debug)
		aslio << "ASL RUN: Asl System has finished one cycle"<<aslend;
		
	return fg;
}
int ASLtrain(int time_step)
{
	int fg = 1;
	
	if (ASL_SYSTEM != NULL)
	{
		if (time_step == 0) 
			fg = ((AslSystem*) ASL_SYSTEM)->AslDoListInitTrain();
		else if (time_step == -1)
			fg = ((AslSystem*) ASL_SYSTEM)->AslDoListEndTrain();
		else
			fg = ((AslSystem*) ASL_SYSTEM)->AslDoListSimTrain();
	}
	else
		cmd_out("ASLrun: Null ASL_SYSTEM");

	if (asl_debug)
		aslio << "ASL INIT: Asl System has finished"<<aslend;
		
	return fg;
}

/*
void AslTclGraphInit(aslArgument arg) 
{
	char *args, buf[20];
	
	Tcl_FindExecutable(arg.argv[0]);
	interp = Tcl_CreateInterp();
             

	args = Tcl_Merge(arg.argc-1, arg.argv+1);

	Tcl_SetVar(interp, "argv", args, TCL_GLOBAL_ONLY);
	ckfree(args);
	sprintf(buf, "%d", arg.argc-1);
	Tcl_SetVar(interp, "argc", buf, TCL_GLOBAL_ONLY);
	Tcl_SetVar(interp, "argv0", arg.argv[0], TCL_GLOBAL_ONLY);
	
	if (Tcl_AppInit(interp) != TCL_OK) {
		aslerr<<"ASL SYSTEM ERROR: Graphics initialization failed"<<aslend;
	}        
	
	Tcl_SourceRCFile(interp);
	Tcl_ResetResult(interp);
	
//AW98	NSL_TK_FLUSH = 1;	//0- no display graphics 1- update graphics
}
void AslTclGeneralScheduler(AslSystem* aslsys)
{
	while (Tk_GetNumMainWindows() > 0) {
        	Tcl_DoOneEvent(TCL_DONT_WAIT); // TCL_DONT_WAIT
        	aslsys->AslDoListStep();
 	}	
}
*/
