/* SCCS  %W%---%E%--%U% */
//
//	nsl_stim_data.c
//

# include "nsl_all_kernel_include.h"
# include "nsl_all_input_include.h"

nsl_stim_data::nsl_stim_data(nsl_input_data* l) : nsl_stim(l)
{
	set_type("stim_data");
	set_base_type("stim");
}
nsl_stim_data::~nsl_stim_data()
{
}

int nsl_stim_data::proc()
{
	return 1;
}
int nsl_stim_data::run()
{
 	float dt = 0;
	float ts = 0;
	int its = 0;

	nsl_model* model = SYSTEM->get_model();
	if (model != NULL)
	{
		dt = model->get_delta();
		ts = model->get_time();
		its = model->get_time_step();
	}
	else
		cmd_error("NULL MODEL");

	if (mode == 0)
		proc(); // virtual
	else if (time_list != NULL)
	{
	   time_list->wind_up();
	   nsl_time_interval* time_obj;
	   while (time_obj = (nsl_time_interval*)time_list->next())
	   {
	    	if (time_obj->get_able_fg() == 0)
			continue;

		float t0 = time_obj->get_t0();
		float t1 = time_obj->get_t1();

		if ((ts >= t0 && ts <= t1))
		{
			proc(); // virtual
		}
	   }
	}
	else
	   cmd_out("NULL 'time_list'");

	return 1;
}
int nsl_stim_data::print(ostream& out) const
{
	return print_stim_data(out);
}
int nsl_stim_data::print_stim_data(ostream& out) const
{
	return print_stim(out);
}
int nsl_stim_data::print_status(ostream& out) const
{
	return print_stim_data_status(out);
}
int nsl_stim_data::print_stim_data_status(ostream& out) const
{
	return print_stim_status(out);
}

