/* SCCS  @(#)nsl_vector_layer.h	1.1---95/08/13--23:37:24 */
//
//	nsl_vector_layer.h
//

class nsl_vector_layer : public nsl_layer
{
protected:
	int i0,i1;
	int imax;

	row_col_enum vec_type;	// 0 - row vector, 1 - col vector
public:
// creation without memory allocation
	nsl_vector_layer(int = 0,int=0,int = 1); 
	nsl_vector_layer(const int,int = 0,int=0,int = 1);
// creation with memory allocation
	nsl_vector_layer(const char*,nsl_model* = 0,int = 0,int=0,int = 1);
	nsl_vector_layer(const char*,const char*,nsl_model* = 0,
		int = 0,int=0,int = 1);
	nsl_vector_layer(const char*,const char*,nsl_model* = 0,
		const int = 0,row_col_enum = NSL_ROW,int = 0,int=0,int=1); 

	virtual ~nsl_vector_layer();

	int init_vector_layer();
	int init_vector_layer(const int);

	// old get
	int	get_x0() const { return i0; }
	int	get_x1() const { return i1; }
	int	get_xn() const { return imax; }
	// get
	int	get_i0() const { return i0; }
	int	get_i1() const { return i1; }
	int	get_imax() const { return imax; }
	int	get_size() const { return imax; }

	// set
	void	set_i0(int i) { i0 = i; }
	void	set_i1(int i) { i1 = i; }

	// transpose vector
	row_col_enum 	set_vec_type(row_col_enum i) 
			{ return vec_type = i; }
	row_col_enum	get_vec_type() const { return vec_type; }

// print
	virtual int	print(ostream&) const;
	int	print_vector_layer(ostream&) const;
	virtual int	print_status(ostream&) const;
	int	print_vector_layer_status(ostream&) const;

	int 	reset_vector_layer(nsl_buffer* = 0);
	virtual int 	reset(nsl_buffer* = 0);

	int 	write_vector_layer(nsl_buffer&);
	virtual int 	write(nsl_buffer&);
	int 	read_vector_layer(nsl_buffer&);
	virtual int 	read(nsl_buffer&);
};

