/* SCCS  @(#)nsl_diff_euler.C	1.1---95/10/13--16:37:19 */
//
// nsl_diff_euler.C
//

# include "nsl_all_kernel_include.h"

nsl_diff_euler::nsl_diff_euler()
{
	init_diff_euler();
}
nsl_diff_euler::~nsl_diff_euler()
{
}
int nsl_diff_euler::init()
{
	if (tm == 0.0)
		cmd_error("nsl_diff_euler: Division by 0");
	else
		p = dt/tm;

	return 1;
}
int nsl_diff_euler::init_diff_euler()
{
	set_name("EULER");
	set_type("euler");
	p = 0.0;
 
	return 1;
}

int nsl_diff_euler::exec(const num_type)
{
	cmd_error("nsl_diff_euler: virtual num_type exec");

	return 1;
}
int nsl_diff_euler::exec(const nsl_num_data&)
{
	cmd_error("nsl_diff_euler: virtual nsl_data exec");

	return 1;
}
int nsl_diff_euler::exec(const nsl_num_vector&)
{
	cmd_error("nsl_diff_euler: virtual nsl_vector exec");

	return 1;
}
int nsl_diff_euler::exec(const nsl_num_matrix&)
{
	cmd_error("nsl_diff_euler: virtual nsl_matrix exec");

	return 1;
}

int nsl_diff_euler::execute(num_type m, num_type tm0, num_type dt0,
	const num_type a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_euler: Division by 0");
		return 0;
	}

	num_type p0 = dt0/tm0;

	m = m + a*p0;

	return 1;
}
int nsl_diff_euler::execute(nsl_num_data& m, num_type tm0, num_type dt0,
	const nsl_num_data& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_euler: Division by 0");
		return 0;
	}

	num_type p0 = dt0/tm0;

	m = m + a*p0;

	return 1;
}
int nsl_diff_euler::execute(nsl_num_data& m, nsl_num_data& tm0, num_type dt0,
	const nsl_num_data& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_euler: Division by 0");
		return 0;
	}

	num_type p0 = dt0/tm0.elem();

	m = m + a*p0;

	return 1;
}
int nsl_diff_euler::execute(nsl_num_vector& m, num_type tm0, num_type dt0,
	const nsl_num_vector& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_euler: Division by 0");
		return 0;
	}

	num_type p0 = dt0/tm0;

	m = m + a*p0;

	return 1;
}
int nsl_diff_euler::execute(nsl_num_vector& m, nsl_num_data& tm0, num_type dt0,
	const nsl_num_vector& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_euler: Division by 0");
		return 0;
	}

	num_type p0 = dt0/tm0.elem();

	m = m + a*p0;

	return 1;
}
int nsl_diff_euler::execute(nsl_num_matrix& m, num_type tm0, num_type dt0,
	const nsl_num_matrix& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_euler: Division by 0");
		return 0;
	}

	num_type p0 = dt0/tm0;

	m = m + a*p0;

	return 1;
}
int nsl_diff_euler::execute(nsl_num_matrix& m, nsl_num_data& tm0, num_type dt0,
	const nsl_num_matrix& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_euler: Division by 0");
		return 0;
	}

	num_type p0 = dt0/tm0.elem();

	m = m + a*p0;

	return 1;
}
int nsl_diff_euler::run(nsl_layer*,nsl_layer*) {
	cmd_error("nsl_diff_euler::run");
	return 0;
}

nsl_diff_method* nsl_diff_euler::make_copy() {
	return new nsl_diff_euler;
}
