/* SCCS  @(#)nsl_diff_interpolation.C	1.1---95/10/13--16:37:21 */
//	
//  nsl_diff_interpolation.C
//

# include "nsl_all_kernel_include.h"

nsl_diff_interpolation::nsl_diff_interpolation()
{
	init_diff_interpolation();
}
nsl_diff_interpolation::~nsl_diff_interpolation()
{
}
int nsl_diff_interpolation::init()
{
	if (tm == 0.0)
		cmd_error("nsl_diff_interpolation: Division by 0");
	else
 		p = exp((num_type)-dt/tm);
	
	return 1;
}
int nsl_diff_interpolation::init_diff_interpolation()
{
	set_name("INTERPOLATION");
	set_type("interpolation");
	p = 0.0;

 	return 1;
}

int nsl_diff_interpolation::exec(const num_type)
{
 	cmd_error("nsl_diff_interpolation: virtual num_type exec");

	return 1;
}
int nsl_diff_interpolation::exec(const nsl_data&)
{
 	cmd_error("nsl_diff_interpolation: virtual nsl_data exec");

	return 1;
}
int nsl_diff_interpolation::exec(const nsl_vector&)
{
 	cmd_error("nsl_diff_interpolation: virtual nsl_vector exec");

	return 1;
}
int nsl_diff_interpolation::exec(const nsl_matrix&)
{
 	cmd_error("nsl_diff_interpolation: virtual nsl_matrix exec");

	return 1;
}
int nsl_diff_interpolation::execute(num_type m, num_type tm0, 
	num_type dt0, const num_type a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_interpolation: Division by 0");
		return 0;
	}

 	num_type p0 = exp((num_type)-dt0/tm0);
	
	m = m + a*(1-p0);

	return 1;
}
int nsl_diff_interpolation::execute(nsl_num_data& m, num_type tm0, 
	num_type dt0, const nsl_num_data& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_interpolation: Division by 0");
		return 0;
	}

 	num_type p0 = exp((num_type)-dt0/tm0);
	
	m = m + a*(1-p0);

	return 1;
}
int nsl_diff_interpolation::execute(nsl_num_data& m, nsl_num_data& tm0, 
	num_type dt0, const nsl_num_data& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_interpolation: Division by 0");
		return 0;
	}

 	num_type p0 = exp((num_type)-dt0/tm0.elem());
	
	m = m + a*(1-p0);

	return 1;
}
int nsl_diff_interpolation::execute(nsl_num_vector& m, num_type tm0, 
	num_type dt0, const nsl_num_vector& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_interpolation: Division by 0");
		return 0;
	}

 	num_type p0 = exp((num_type)-dt0/tm0);
	
	m = m + a*(1-p0);

	return 1;
}
int nsl_diff_interpolation::execute(nsl_num_vector& m, nsl_num_data& tm0, 
	num_type dt0, const nsl_num_vector& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_interpolation: Division by 0");
		return 0;
	}

 	num_type p0 = exp((num_type)-dt0/tm0.elem());
	
	m = m + a*(1-p0);

	return 1;
}
int nsl_diff_interpolation::execute(nsl_num_matrix& m, num_type tm0, 
	num_type dt0, const nsl_num_matrix& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_interpolation: Division by 0");
		return 0;
	}

 	num_type p0 = exp((num_type)-dt0/tm0);
	
	m = m + a*(1-p0);

	return 1;
}
int nsl_diff_interpolation::execute(nsl_num_matrix& m, nsl_num_data& tm0, 
	num_type dt0, const nsl_num_matrix& a)
{
	if (tm0 == 0) {
		cmd_error("nsl_diff_interpolation: Division by 0");
		return 0;
	}

 	num_type p0 = exp((num_type)-dt0/tm0.elem());
	
	m = m + a*(1-p0);

	return 1;
}
int nsl_diff_interpolation::run(nsl_layer*,nsl_layer*) {
	cmd_error("nsl_diff_interpolation::run");
	return 0;
}

nsl_diff_method* nsl_diff_interpolation::make_copy() {
	return new nsl_diff_interpolation;
}
