/* SCCS  @(#)xnsl_temporal_graph_data.C	1.1---96/02/20--19:21:45 */
//
//	xnsl_temporal_graph_data.C
//

#include "nsl_all_kernel_include.h"
#include "xnsl_all_xkernel_include.h"

xnsl_temporal_graph_data::xnsl_temporal_graph_data(xnsl_display_canvas* win,
	nsl_data* m) : xnsl_temporal_graph(win)
{
        set_type("temporal_graph_data");

	if (m != NULL)
	{
		_layer = m;
		_layer0 = new nsl_data;
	}
//	else
//		cmd_error("xnsl_temporal_graph_dat: NULL layer");
}
xnsl_temporal_graph_data::~xnsl_temporal_graph_data()
{
}
xnsl_widget * xnsl_temporal_graph_data::make_widget()
{
        return new xnsl_temporal_graph_data((xnsl_display_canvas*) m_parent,
		(nsl_data*) _layer);
}
int xnsl_temporal_graph_data::display()
{
	set_env("",_X0,_Y0,_width,_height,_wx0,_wy0,_wx1,_wy1,_wxs,_wys);
 
	return 1;
}
int xnsl_temporal_graph_data::display_temporal_graph(
	int wx0,int wy0,int wx1,int wy1,int wxs,int wys,
	num_type wymin, num_type wymax) 
{
	nsl_model* model;

	if ((model = SYSTEM->get_model()) == NULL)
	{
		cmd_error("NULL MODEL");
		return 1;
	}

	float ts = model->get_time();
	float dt = model->get_delta();

	num_type m0 = ((nsl_data*) _layer0)->get_data();
	num_type m = ((nsl_data*) _layer)->get_data();
       /* aa 95/4/23 b */
       if (m<wymin) {
               m=wymin;
       }
       else if (m>wymax) m=wymax;
       /* aa 95/4/23 e */


//	draw_temporal_graph_data(canvas,m,m0,
//		wx0,wy0,wxs,wys,wymin,wymax,t0,t1,ts,dt,pulsefg);

        int ux0,uy0;
        num_type u0,u1,v0,v1;
        num_type x,y;
        int xc,yc,xp,yp;

        num_type fx0 = get_t0();
        num_type fx1 = get_t1();

        num_type fy0 = wymin;
        num_type fy1 = wymax;

//      if (breakfg == 1)
//          return(1);

        if (ts >= 0.0)
        {
            ux0 = wx0;
            uy0 = wy0;
            u0 = (num_type) ux0;
            u1 = (num_type) wxs;
            v0 = (num_type) uy0;
            v1 = (num_type) wys;

            x = ts; 
            y = m;
            xc = coord_transform(x,fx0,fx1,u0,u1);
            yc = coord_transform(y,fy0,fy1,v0,v1);
            if (ts == 0.0)
            {
                xp = coord_transform(x,fx0,fx1,u0,u1);
                yp = coord_transform(y,fy0,fy1,v0,v1);
            }
            else
            {
                x = ts-dt;
                y = m0;
                xp = coord_transform(x,fx0,fx1,u0,u1);
                yp = coord_transform(y,fy0,fy1,v0,v1);
            }
	    if (xp != xc || yp != yc)
	    {
	        if (pulsefg == 1)
                {
                	draw_line(xp,yp,xp,yc);
                	yp = yc;
                }
                draw_line(xp,yp,xc,yc);
	    }
        }

	((nsl_data*) _layer0)->set_value(m);
 
	return 1;
}

int xnsl_temporal_graph_data::read_from_database()
{
	return 1;
}
int xnsl_temporal_graph_data::write_to_database()
{
	return 1;
}
int xnsl_temporal_graph_data::print(ostream& out) const
{
	xnsl_temporal_graph::print(out);

	return 1;
}

