/* SCCS  @(#)xnsl_tcltk_canvas.C	1.1---95/08/13--21:01:49 */
//////////////////////////////////////////////////////////////////////////
//
//  xnsl_tcltk_canvas.C: Class that creates the tcltk drawing area widget.
//             
//////////////////////////////////////////////////////////////////////////

#include "nsl_all_kernel_include.h"
#include "xnsl_all_xkernel_include.h"
#include "xnsl_tcltk_include.h"

xnsl_tcltk_canvas::xnsl_tcltk_canvas() : xnsl_tcltk_widget()
{
	set_type("canvas");
}  

xnsl_tcltk_canvas::~xnsl_tcltk_canvas()
{
}  

int xnsl_tcltk_canvas::clear_area(int wx0,int wy0,int wx1,int wy1)
{
//	(wx0,wy0) is lower left corner.
//	 wx1: width, wy1: height

	nsl_string str;
	char c = ' '; // 'p' // printer points

	sprintf(str,"%s create rectangle %d%c %d%c %d%c %d%c -fill white" \
		,_wname,wx0,c,wy0,c,wx0+wx1,c,wy0+wy1,c);

	Tcl_Eval(NSL_TCL_INTERP,str);

	return 1;
}
void  xnsl_tcltk_canvas::redraw()
{
//     XCopyPlane(XtDisplay(_object), _xwin,XtWindow(_object),
//        _gc, 0, 0, _width,_height, 0, 0, 1);
}
	
xnsl_widget*  xnsl_tcltk_canvas::create_widget(const char   *wname, 
	xnsl_widget     *pxnsl_widget, int, int,
	int width, int height, int, int, int, int, int, int,
	const char* side, const char*) // side taken from label
{
     strcpy(_wname,wname);
     _width = width;
     _height = height;

	nsl_string str;

	char c = ' '; // 'p'

/*	sprintf(str,"frame %s -relief groove -borderwidth 4",wname);

	Tcl_Eval(NSL_TCL_INTERP,str);

	sprintf(str,"pack %s -side %s",wname,side); // left, top

	Tcl_Eval(NSL_TCL_INTERP,str);
*/
	sprintf(str,"canvas %s -width %d%c -height %d%c -background white",wname,_width,c,_height,c);

	Tcl_Eval(NSL_TCL_INTERP,str);

	sprintf(str,"pack %s",wname);

	Tcl_Eval(NSL_TCL_INTERP,str);
	
   return (this);

}   // End function create_widget

void xnsl_tcltk_canvas::set_env (const char	*wname,
	int	x,int	y,int	width,int	height,
	int,int,int,int,int,int,const char* label, const char* message)
{
    	strcpy(_wname,wname);
	_X0		= x;
	_Y0		= y;
	_width		= width;
	_height		= height;

}  // End of function set_canvas_env
				

/////////////////////////////////////////////////////////////////////////////
//
//	Function :   	make_widget
//
////////////////////////////////////////////////////////////////////////////

xnsl_widget *xnsl_tcltk_canvas::make_widget()
{
	return new xnsl_tcltk_canvas();
}
			

// End of file.


